// The Dictionary class is basically a wrapped hash_set to hold words.
//
// Chris Dahlberg
// 2/17/04

#ifndef __DICTIONARY__
#define __DICTIONARY__



#include <hash_set>
#include <string>
#include "word.h"
#include "windows.h"


using namespace std;
using namespace stdext;


class Dictionary
{
public:
	Dictionary();
	~Dictionary();

	void insert(word toInsert);
	wstring lookUpEngDef(wstring kanji) const;
	wstring lookUpKana(wstring kanji) const;

private:

struct wordHash 
{
	size_t operator() (const word& toHash) const 
	{
		return hash(toHash.kanji_);
	}

	size_t hash(wstring toHash) const
	{
		size_t accum = 0;
		for (	wstring::const_iterator i = toHash.begin(); 
				i != toHash.end();
				++i)
		{
			WCHAR x = *i;
			accum = accum * 37 + *i;
		}		
		return accum;
	}

	size_t operator() (const word& lhs, const word& rhs) const
	{
		return lhs.kanji_ < rhs.kanji_;
	}

	const static int bucket_size = 4;
	const static int min_buckets = 8;
};




	hash_set<word, wordHash> dict_;
};

#endif